;=======================================================================
;
;	NSF ROM code for NSD.Lib
;
;				Programmed by A.Watanabe
;
;=======================================================================

;-------------------------------
;Memory Map of this NSF program code
;-------------------------------
;Address	Type	Contents
;0x8000		BYTE	BGM
;0x8001		BYTE	SE
;0x8002		WORD	PCM\̂̃|C^
;0x8004-	WORD	BGMSEf[^̃|C^
;``			BGM,SE,Gx[vAFf[^  PCM\
;0xC000-		PCM
;0xE000-		vOR[h

	.export		__STARTUP__ : absolute = 1      ; Mark as startup

	; Linker generated symbols
	.import		__RAM_START__, __RAM_SIZE__
	.import		__SRAM_START__, __SRAM_SIZE__
	.import		__ROM0_START__, __ROM0_SIZE__, __ROM0_LAST__
	.import		__STARTUP_LOAD__,__STARTUP_RUN__, __STARTUP_SIZE__
	.import		__CODE_LOAD__,__CODE_RUN__, __CODE_SIZE__
	.import		__RODATA_LOAD__,__RODATA_RUN__, __RODATA_SIZE__

	.include	"..\..\include\nsd.inc"

; ------------------------------------------------------------------------
; ϐ
; ------------------------------------------------------------------------
.zeropage

_ptr:	.word	0
_tmp:	.word	0

; ------------------------------------------------------------------------
; 16 bytes INES header
; ------------------------------------------------------------------------

mus_no	= 12


.segment	"HEADER"

	.byte	$4E,$45,$53,$4D,$1A	;00	"NESM",0x1A
	.byte	1			;05	Version
	.byte	mus_no			;06	Music number
	.byte	1			;07	Start Music number
	.addr	$8000			;08	Load address
	.addr	_nsf_init		;0A	Init routine address
	.addr	_nsf_main		;0C	Sound driver main routine address
	.asciiz	"Music from SORCERIAN for nsdlib"
	.asciiz	"sound team j.d.k./arranged:S.W."
	.asciiz	"Nihon Falcom Corporation       "
	.word	$411A			;6E	60Hz
	.byte	4,5,6,7,0,1,2,3		;70	bank
	.word	$4E20			;78
	.byte	0			;7A
	.byte	0
	.byte	0,0,0,0			;78

; ------------------------------------------------------------------------
; 	@ROMp	Reset
; ------------------------------------------------------------------------
.segment	"STARTUP"

.ifdef	DPCMBank
; ------------------------------------------------------------------------
; 	@ROMp	IRQ	(DPCM)
; ------------------------------------------------------------------------
.proc	_irq_main

	pha			;register push
	tya
	pha
	txa
	pha

;	jsr	_nsd_irq_main

	pla			;register pop
	tax
	pla
	tay
	pla

	rti
.endproc

; ------------------------------------------------------------------------
; 	@ROMp	NMI	(Vblank)
; ------------------------------------------------------------------------
.proc	_nmi_main

	pha			;register push
	tya
	pha
	txa
	pha

	jsr	_nsd_main

	pla			;register pop
	tax
	pla
	tay
	pla

	rti

.endproc

.endif
; ------------------------------------------------------------------------
; 	NSFp
; ------------------------------------------------------------------------
.proc	_nsf_main

	jmp	_nsd_main

.endproc

; ------------------------------------------------------------------------
; 	Init
; ------------------------------------------------------------------------
.proc	_nsf_init
	pha

	jsr	_zero_mem

	jsr	_init

	pla
	jsr	_play_music

	rts
.endproc

; ------------------------------------------------------------------------
; 	Zero memory
; ------------------------------------------------------------------------
.proc	_zero_mem
	lda	#0
	ldx	#0

@L:
	sta	$0000,x	;Stack̓NAȂB
	sta	$0200,x
	sta	$0300,x
	sta	$0400,x
	sta	$0500,x
	sta	$0600,x
	sta	$0700,x
	inx
	bne	@L


	rts
.endproc

; ------------------------------------------------------------------------
; 	set bank
; ------------------------------------------------------------------------
.code
.proc	set_bank

	asl	a
	asl	a
	tax

	stx	$5FF8
	inx
	stx	$5FF9
	inx
	stx	$5FFA
	inx
	stx	$5FFB

	rts
.endproc
; ------------------------------------------------------------------------
; 	init
; ------------------------------------------------------------------------
.rodata


.code
.proc	_init

	jsr	_nsd_init

	rts
.endproc

; ------------------------------------------------------------------------
; 	play music
; ------------------------------------------------------------------------
.rodata

	.import	_sor_m0_DPCMinfo
	.import	_sor_m1_DPCMinfo

dinfo:	.addr	_sor_m0_DPCMinfo	;bank 0 (bgm 0)
	.addr	_sor_m1_DPCMinfo	;bank 2 (bgm 1)

	.import		_sor_m0_BGM0
	.import		_sor_m0_BGM1
	.import		_sor_m0_BGM2
	.import		_sor_m0_BGM3
	.import		_sor_m0_BGM4
	.import		_sor_m0_BGM5

	.import		_sor_m1_BGM0
	.import		_sor_m1_BGM1
	.import		_sor_m1_BGM2
	.import		_sor_m1_BGM3
	.import		_sor_m1_BGM4
	.import		_sor_m1_BGM5

bgm:	.addr		_sor_m0_BGM0
	.addr		_sor_m0_BGM1
	.addr		_sor_m0_BGM2
	.addr		_sor_m0_BGM3
	.addr		_sor_m0_BGM4
	.addr		_sor_m0_BGM5

	.addr		_sor_m1_BGM0
	.addr		_sor_m1_BGM1
	.addr		_sor_m1_BGM2
	.addr		_sor_m1_BGM3
	.addr		_sor_m1_BGM4
	.addr		_sor_m1_BGM5

seg:	.byte	0,0,0,0,0,0

	.byte	1,1,1,1,1,1

.code
.proc	_play_music

	pha

	;get music bank number
	tay
	lda	seg,y

	;set bank
	tay
	clc
	adc	#1
	jsr	set_bank
	tya

	;set d-pcm infomation
	asl	a
	tay
	lda	dinfo,y
	ldx	dinfo + 1,y
	jsr	_nsd_set_dpcm

	pla

	;play bgm
	asl	a
	tay
	lda	bgm + 1,y
	tax
	lda	bgm,y
	jmp	_nsd_play_bgm

.endproc

