SUN5B_ADDR	=	$C000
SUN5B_DATA	=	$E000

sun5b_reg7	=	fme7_adr		;R7ݒl
sun5b_temp	=	fme7_data
sun5b_tone	=	register_high
sun5b_volume	=	register_low
;----------------------------------------
fme7_sound_init:
	ldy	#$0A
	lda	#$00
.loop:
	sty	SUN5B_ADDR
	sta	SUN5B_DATA
	dey
	cpy	#$07
	bne	.loop
	lda	#%11111000
	sty	SUN5B_ADDR
	sta	SUN5B_DATA
	sta	sun5b_reg7
	rts
;----------------------------------------
sound_fme7:
	lda	channel_sel
	asl	a
	tax
	dec	sound_counter,x
	bne	sun5b_do_effect
	jsr	sound_sun5b_read
	jsr	sun5b_do_effect
	lda	rest_flag,x
	and	#%00000010
	beq	sun5b_return1990
	jsr	sound_sun5b_write
	lda	rest_flag,x
	and	#%11111101
	sta	rest_flag,x
sun5b_return1990:
	rts

sun5b_do_effect:
	lda	rest_flag,x
	and	#%00000001
	bne	sun5b_return2010
sun5b_softenve_write:
	lda	effect_flag,x
	and	#%00000001
	beq	sun5b_lfo_write
	jsr	sound_sun5b_softenve
sun5b_lfo_write:
	lda	effect_flag,x
	and	#%00010000
	beq	sun5b_pitch_enve_write
	jsr	sound_sun5b_lfo
sun5b_pitch_enve_write:
	lda	effect_flag,x
	and	#%00000010
	beq	sun5b_note_enve_write
	jsr	sound_sun5b_pitch_enve
sun5b_note_enve_write:
	lda	effect_flag,x
	and	#%00001000
	beq	sun5b_return2010
	jsr	sound_sun5b_note_enve
sun5b_return2010:
	rts
;------------------------------------------------
sun5b_freq_set:
	lda	sun5b_tone,x
	cmp	#$02
	beq	sun5b_noise_freq_set
	lda	sound_sel,x		;Kf[^ǂݏo
	and	#%00001111		;4bito
	asl	a
	tay

	lda	sun5b_frequency_table,y	;Sun5Bge[uLowǂݏo
	sta	sound_freq_low,x	;
	iny				;yP₵
	lda	sun5b_frequency_table,y	;Sun5Bge[uHighǂݏo
	sta	sound_freq_high,x	;

sun5b_oct_set1:

	lda	sound_sel,x		;Kf[^ǂݏo
	lsr	a			;4bito
	lsr	a			;
	lsr	a			;
	lsr	a			;
	beq	sun5b_freq_end		;[Ȃ炻̂܂܏I
	tay

	lda	sound_freq_low,x
sun5b_oct_set2:
	lsr	sound_freq_high,x	;EVtg@C
	ror	a			;C玝Ăł@E[eCg
	dey				;
	bne	sun5b_oct_set2		;IN^[uJԂ

	adc	#$00			;Ōɐ؂̂ĂC𑫂(ľܓ)
	sta	sound_freq_low,x
	bcc	sun5b_freq_end
	inc	sound_freq_high,x

sun5b_freq_end:
	jsr	detune_write_sub
	rts

sun5b_noise_freq_set:
	lda	sound_sel,x		;Kf[^ǂݏo
	sta	sound_freq_low,x	;̂܂
	rts
;------------------------------------------------
sun5b_frequency_table:
	dw	$0D5C,$0C9D,$0BE7,$0B3C	; o0c  c+ d  d+
	dw	$0A9B,$0A02,$0973,$08EB	;   e  f  f+ g
	dw	$086B,$07F2,$0780,$0714	;   g+ a  a+ b
	dw	$0000,$0FE4,$0EFF,$0E28	; o-1  a  a+ b
; Đg = 1789772.5 / (n*32) [Hz]
;------------------------------------------------
sound_sun5b_read:
	jsr	reg400x

	lda	sound_bank,x
	jsr	change_bank

	lda	[sound_add_low,x]
;----------
;[v1
sun5b_loop_program:
	cmp	#$a0
	bne	sun5b_loop_program2
	jsr	loop_sub
	jmp	sound_sun5b_read
;----------
;[v2()
sun5b_loop_program2:
	cmp	#$a1
	bne	sun5b_bank_command
	jsr	loop_sub2
	jmp	sound_sun5b_read
;----------
;oN؂ւ
sun5b_bank_command:
	cmp	#$ee
	bne	sun5b_data_end
	jsr	data_bank_addr
	jmp	sound_sun5b_read
;----------
;f[^Ghݒ
sun5b_data_end:
	cmp	#$ff
	bne	sun5b_tone_set
	jsr	data_end_sub
	jmp	sound_sun5b_read
;----------
;Fݒ
sun5b_tone_set:
	cmp	#$fe
	bne	sun5b_volume_set
	jsr	sound_data_address
	lda	sun5b_enable_bit_tbl-PTRFME7*4,y
	eor	#$FF
	and	sun5b_reg7
	sta	sun5b_reg7
	sty	sun5b_temp
	lda	[sound_add_low,x]	;Ff[^ǂݏo
	and	#%00000011
	sta	sun5b_tone,x
	clc
	adc	sun5b_temp
	tay
	lda	sun5b_enable_bit_tbl-PTRFME7*4,y
	ora	sun5b_reg7
	sta	sun5b_reg7
	ldy	#$07
	sty	SUN5B_ADDR
	sta	SUN5B_DATA
	jsr	sound_data_address
	jmp	sound_sun5b_read

sun5b_enable_bit_tbl:
	db	%00001001, %00001000, %00000001, %00000000
	db	%00010010, %00010000, %00000010, %00000000
	db	%00100100, %00100000, %00000100, %00000000
;----------
;ʐݒ
sun5b_volume_set:
	cmp	#$fd
	bne	sun5b_rest_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	temporary
	bpl	sun5b_softenve_part	;\tgGx

sun5b_volume_part:
	lda	effect_flag,x
	and	#%11111110
	sta	effect_flag,x		;\tgGxw

	lda	temporary
	and	#%00011111
	sta	sun5b_volume,x
	tay
	jsr	sun5b_volume_write_sub

	jsr	sound_data_address
	jmp	sound_sun5b_read

sun5b_softenve_part:
	jsr	volume_sub
	jmp	sound_sun5b_read
;----------
sun5b_rest_set:
	cmp	#$fc
	bne	sun5b_lfo_set

	lda	rest_flag,x
	ora	#%00000001
	sta	rest_flag,x

	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_counter,x

	ldy	#$00
	jsr	sun5b_volume_write_sub

	jsr	sound_data_address
	rts
;----------
sun5b_lfo_set:
	cmp	#$fb
	bne	sun5b_detune_set
	jsr	lfo_set_sub
	jmp	sound_sun5b_read
;----------
sun5b_detune_set:
	cmp	#$fa
	bne	sun5b_pitch_set
	jsr	detune_sub
	jmp	sound_sun5b_read
;----------
;sb`Gx[vݒ
sun5b_pitch_set:
	cmp	#$f8
	bne	sun5b_arpeggio_set
	jsr	pitch_set_sub
	jmp	sound_sun5b_read
;----------
;m[gGx[vݒ
sun5b_arpeggio_set:
	cmp	#$f7
	bne	sun5b_freq_direct_set
	jsr	arpeggio_set_sub
	jmp	sound_sun5b_read
;----------
;Đgڐݒ
sun5b_freq_direct_set:
	cmp	#$f6
	bne	sun5b_y_command_set
	jsr	direct_freq_sub
	rts
;----------
;R}hݒ
sun5b_y_command_set:
	cmp	#$f5
	bne	sun5b_wait_set
	jsr	y_sub
	jmp	sound_sun5b_read
;----------
;EFCgݒ
sun5b_wait_set:
	cmp	#$f4
	bne	sun5b_hard_speed_set
	jsr	wait_sub
	rts
;----------
;n[hEFAGx[vxݒ
sun5b_hard_speed_set:
	cmp	#$f2
	bne	sun5b_noise_set
	jsr	sound_data_address
	ldy	#$0B
	lda	[sound_add_low,x]
	sty	SUN5B_ADDR
	sta	SUN5B_DATA
	iny
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sty	SUN5B_ADDR
	sta	SUN5B_DATA
	jsr	sound_data_address
	jmp	sound_sun5b_read
;----------
;mCYgݒ
sun5b_noise_set:
	cmp	#$f1
	bne	sun5b_oto_set
	jsr	sound_data_address
	ldy	#$06
	lda	[sound_add_low,x]
	sty	SUN5B_ADDR
	sta	SUN5B_DATA
	jsr	sound_data_address
	jmp	sound_sun5b_read
;----------
sun5b_oto_set:
	sta	sound_sel,x		;͂܂
	jsr	sound_data_address
	lda	[sound_add_low,x]	;ǂݏo
	sta	sound_counter,x		;ۂ̃JEglƂȂ܂
	jsr	sound_data_address
	jsr	sun5b_freq_set		;gZbg
	jsr	effect_init
	rts
;-------------------------------------------------------------------------------
sound_sun5b_write:
	ldy	sun5b_volume,x
	jsr	sun5b_volume_write_sub

sun5b_write:
	lda	sun5b_tone,x
	cmp	#$02
	beq	sun5b_noise_write	;mCY̓mCYgo

	lda	channel_sel
	sec
	sbc	#PTRFME7
	asl	a
	tay

	lda	sound_freq_low,x
	sty	SUN5B_ADDR
	sta	SUN5B_DATA
	iny
	lda	sound_freq_high,x
	sty	SUN5B_ADDR
	sta	SUN5B_DATA
	rts

sun5b_noise_write:
	ldy	#$06
	lda	sound_freq_low,x
	and	#%00011111
	sty	SUN5B_ADDR
	sta	SUN5B_DATA
	rts
;----------------------------------------
sun5b_volume_write_sub:
	cpy	#$10
	bcc	.write_vol
	tya
	and	#%00001111
	ldy	#$0D
	sty	SUN5B_ADDR
	sta	SUN5B_DATA
	ldy	#$10
.write_vol:
	lda	channel_sel
	sec
	sbc	#PTRFME7
	clc
	adc	#$08
	sta	SUN5B_ADDR
	sty	SUN5B_DATA
	rts
;-----------------------------------------------------
sound_sun5b_softenve:
	jsr	volume_enve_sub
	sta	sun5b_volume,x
	tay
	jsr	sun5b_volume_write_sub
	jmp	enverope_address
;-------------------------------------------------------------------------------
sound_sun5b_lfo:
	jsr	lfo_sub
	jmp	sun5b_write
;-------------------------------------------------------------------------------
sound_sun5b_pitch_enve:
	jsr	pitch_sub
	jsr	sun5b_write
	jmp	pitch_enverope_address
;-------------------------------------------------------------------------------
sound_sun5b_note_enve
	jsr	note_enve_sub
	jsr	sun5b_freq_set
	jsr	sun5b_write
	jmp	arpeggio_address
;-------------------------------------------------------------------------------
