;---------------------------------------------------
ex_apu_freq
		cpx	#$07
		bne	.note_set
.note_set
		sec
		sbc	#$15
		sta	SND_NOTE,x
		jsr	sound_data_add
		sta	SND_COUNT,x
		lda	SND_NOTE,x
		asl	a
		tay
		lda	PULSE_FREQ_TBL,y
		sta	SND_FREQ_L,x
		lda	PULSE_FREQ_TBL+1,y
		sta	SND_FREQ_H,x
		lda	DT_VALUE,x
		bne	.freq_detune_set
		jmp	sound_effect_init
.freq_detune_set
		lda	DT_VALUE,x
		clc
		bmi	.freq_minus
		adc	SND_FREQ_L,x
		sta	SND_FREQ_L,x
		bcc	.return
		inc	SND_FREQ_H,x
		bne	.return
.freq_minus
		adc	SND_FREQ_L,x
		sta	SND_FREQ_L,x
		bcs	.return
		dec	SND_FREQ_H,x
.return
		jmp	sound_effect_init
;---------------------------------------------------
ex_apu_reg
		cpx	#$06
		beq	.regA000
		cpx	#$07
		beq	.regB000
.reg9000
		lda	R4000_L,x
		ora	R4000_H,x
		sta	$9000
		lda	SND_FREQ_L,x
		sta	$9001
		lda	SND_FREQ_H,x
		sta	$9002
		rts
.regA000
		lda	R4000_L,x
		ora	R4000_H,x
		sta	$a000
		lda	SND_FREQ_L,x
		sta	$a001
		lda	SND_FREQ_H,x
		sta	$a002
		rts
.regB000
		lda	R4000_L,x
		ora	R4000_H,x
		sta	$b000
		lda	SND_FREQ_L,x
		sta	$b001
		lda	SND_FREQ_H,x
		sta	$b002
		rts
;---------------------------------------------------
;regs 9000-9002 are for pulse channel #1
;regs a000-a002 are for pulse channel #2
;regs b000-b002 are for the phase accumulator channel (sawtooth)
;
;9000h: GDDDVVVV
;
;        D - Duty Cycle bits:
;
;          000 - 1/16th  ( 6.25%)
;          001 - 2/16ths (12.50%)
;          010 - 3/16ths (18.75%)
;          011 - 4/16ths (25.00%)
;          100 - 5/16ths (31.25%)
;          101 - 6/16ths (37.50%)
;          110 - 7/16ths (43.75%)
;          111 - 8/16ths (50.00%)
;
;        V - Volume bits. 0000b is silence, 1111b is loudest.  Volume is 
;        linear.  When in "normal" mode (see G bit), this acts as a general 
;        volume control register.  When in "digitized" mode, these act as a 
;        4 bit sample input.
;
;        G - Gate bit. 0=normal operation, 1=digitized.  In digi operation, 
;        registers 9001h and 9002h are totally disabled.  Only bits 0-3 of 
;        9000h are used.  Whatever binary word is present here is passed on 
;        as a 4 bit digitized output.
;
;9002h: FFFFFFFF 
;
;        F - Lower 8 bits of frequency data
;
;
;9003h: X---FFFF
;
;        X - Channel disable.  0=channel disabled, 1=channel enabled.
;
;        F - Upper 4 bits of frequency data
;
;
;B000h: --PPPPPP
;
;        P - Phase accumulator input bits
;
;B001h: FFFFFFFF 
;
;        F - Lower 8 bits of frequency data
;
;B002h: X---FFFF
;
;        X - Channel disable. 0=channel disabled, 1=channel enabled.
;
;        F - Upper 4 bits of frequency data
;
;Pulse
;         1789772.7272
;Fout = ----------------
;       (freq_in+1) * 16
;
;111860.79545Hz
;48.550692469618055555555555555556Hz܂
;o4a:$FD+1
;
;Saw
;         1789772.7272
;Fout = ----------------
;       (freq_in+1) * 14
;
;127840.90908571428571428571428571Hz
;55.486505679563492063492063492063Hz܂
;o4a$0121+1
;1.7897725MHz
;g21.47727MH121.7897725MHzB
;--------------------------------------------------
;H
	dw	$0D5C,$0C9C,$0BE8,$0B3C,$0A9C,$0A02,$0972,$08EC
	dw	$8723,$086C,$07F2,$0780,$0714
;H
	dw	$0F44,$0E68,$0D9A,$0CD6,$0C1E,$0B70,$0ACC,$0A30
	dw	$09A4,$0914,$0890,$0816

saw_freq_table
	dw	$07A2,$0734,$06CD,$066B,$060F,$06B8,$0566,$0518
	dw	$04D2,$048A,$0448,$040B,$03D1,$039A,$0366,$0335
	dw	$0307,$02DC,$02B3,$028C,$0269,$0245,$0224,$0205

;-------------------------------------------------
